## g2o 0~20230806

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

project(g2o)

include(CPack)
include(GNUInstallDirs)

# The library prefix
set(LIB_PREFIX g2o_)

set(g2o_C_FLAGS)
set(g2o_CXX_FLAGS)

set(G2O_LIB_VERSION   "0.1.0" CACHE STRING "g2o library version")
set(G2O_LIB_SOVERSION "0.1"   CACHE STRING "g2o library soversion")

# manually check for top-level project if CMake is older than 3.21
if(CMAKE_VERSION VERSION_LESS 3.21)
  string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}" PROJECT_IS_TOP_LEVEL)
endif()

if(PROJECT_IS_TOP_LEVEL)
  # default built type
  if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
            "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
            FORCE)
  endif()
endif()

# Allow the developer to select if Dynamic or Static libraries are built
option (BUILD_SHARED_LIBS "Build Shared Libraries (preferred and required for the g2o plugin system)" ON)
set (G2O_LIB_TYPE STATIC)
if (BUILD_SHARED_LIBS)
  set (G2O_LIB_TYPE SHARED)
endif()

# On the Mac platform, configure the RPATH as per the INSTALL, to
# avoid the problem of loading both the built and INSTALLed versions
# of the shared targets
if(APPLE)
  set(CMAKE_INSTALL_RPATH "")
  set(CMAKE_MACOSX_RPATH TRUE)
  # ignore deprecated GL
  add_definitions(-DGL_SILENCE_DEPRECATION)
endif(APPLE)

# Set the output directory for the build executables and libraries
set(g2o_RUNTIME_OUTPUT_DIRECTORY ${g2o_BINARY_DIR}/bin CACHE PATH "Target for the binaries")
if(WIN32)
  set(g2o_LIBRARY_OUTPUT_DIRECTORY ${g2o_BINARY_DIR}/bin CACHE PATH "Target for the libraries")
else(WIN32)
  set(g2o_LIBRARY_OUTPUT_DIRECTORY ${g2o_BINARY_DIR}/lib CACHE PATH "Target for the libraries")
endif(WIN32)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${g2o_LIBRARY_OUTPUT_DIRECTORY})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${g2o_LIBRARY_OUTPUT_DIRECTORY})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${g2o_RUNTIME_OUTPUT_DIRECTORY})

# Set standard installation directories
set(RUNTIME_DESTINATION ${CMAKE_INSTALL_BINDIR})
set(LIBRARY_DESTINATION ${CMAKE_INSTALL_LIBDIR})
set(ARCHIVE_DESTINATION ${CMAKE_INSTALL_LIBDIR})
set(INCLUDES_DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
set(INCLUDES_INSTALL_DIR ${INCLUDES_DESTINATION}/g2o)

# Set search directory for looking for our custom CMake scripts to
# look for SuiteSparse, QGLViewer, and Eigen3.
list(APPEND CMAKE_MODULE_PATH ${g2o_SOURCE_DIR}/cmake_modules)

# Detect OS and define macros appropriately
if(WIN32)
  add_definitions(-DWINDOWS)
  message(STATUS "Compiling on Windows")
elseif(CYGWIN)
  message(STATUS "Compiling on Cygwin")
  add_definitions(-DCYGWIN)
elseif(APPLE)
  add_definitions(-DUNIX)
  message(STATUS "Compiling on OSX")
elseif(UNIX)
  add_definitions(-DUNIX)
  message(STATUS "Compiling on Unix")
endif(WIN32)

# detect Android Cross Compiler
# based on android-cmake which sets the variable ANDROID for us
if(ANDROID)
  add_definitions(-DANDROID)
  message(STATUS "Cross compiling for Android")
endif()

# For building the CHOLMOD based solvers
option(G2O_USE_CHOLMOD "Build g2o with CHOLMOD support" ON)
find_package(SuiteSparse)
if (G2O_USE_CHOLMOD AND SuiteSparse_CHOLMOD_FOUND)
  message(STATUS "Enable support for Cholmod")
  set(CHOLMOD_FOUND TRUE)
else()
  message(STATUS "Disable support for Cholmod")
  set(CHOLMOD_FOUND FALSE)
endif()

# Options to control the LGPL libraries
option(G2O_USE_LGPL_LIBS "Build libraries which use LGPL code" TRUE)

# If the LGPL libraries are used, check if static or shared libraries are used and
# show a suitable message
if (G2O_USE_LGPL_LIBS)
  if (G2O_LIB_TYPE STREQUAL "STATIC")
    message(STATUS "Building LGPL code as a static library (affects license of the binary)")
  else()
    message(STATUS "Building LGPL code as a shared library")
  endif()
endif()

# Adapter for the legacy LGPL flags. Note there is an inconsistency with the old implementation.
if (BUILD_LGPL_SHARED_LIBS)
  if (G2O_LIB_TYPE STREQUAL "SHARED")
    set(G2O_USE_LGPL_LIBS TRUE)
  else()
    message(FATAL_ERROR "BUILD_LGPL_SHARED_LIBS is set to true but G2O_LIB_TYPE is set to STATIC")
  endif()
endif()

# For building the CSparse based solvers. Note this depends on an LGPL library.
option(G2O_USE_CSPARSE "Build g2o with CSParse support" ON)
find_package(CSparse)
if (${G2O_USE_CSPARSE} AND ${CSPARSE_FOUND} AND ${G2O_USE_LGPL_LIBS})
  message(STATUS "Enable support for CSparse")
else()
  message(STATUS "Disable support for CSparse")
  set(G2O_USE_CSPARSE FALSE)
endif()


# Eigen library parallelise itself, though, presumably due to performance issues
# OPENMP is experimental. We experienced some slowdown with it
option(G2O_USE_OPENMP "Build g2o with OpenMP support (EXPERIMENTAL)" OFF)
if(G2O_USE_OPENMP)
  find_package(OpenMP)
  if(OPENMP_FOUND)
    set (G2O_OPENMP 1)
    set(g2o_C_FLAGS "${g2o_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(g2o_CXX_FLAGS "${g2o_CXX_FLAGS} -DEIGEN_DONT_PARALLELIZE ${OpenMP_CXX_FLAGS}")
    message(STATUS "Compiling with OpenMP support")
  endif(OPENMP_FOUND)
endif(G2O_USE_OPENMP)

# OpenGL is used in the draw actions for the different types, as well
# as for creating the GUI itself
set(OpenGL_GL_PREFERENCE "GLVND")
find_package(OpenGL)

# If OpenGL was found, use the import target if available. If not, use old-style includes
option(G2O_USE_OPENGL "Build g2o with OpenGL support for visualization" ON)
if (OPENGL_FOUND AND G2O_USE_OPENGL)
  if (TARGET OpenGL::GL)
    set(G2O_OPENGL_TARGET "OpenGL::GL;OpenGL::GLU")
  else()
    set(G2O_OPENGL_TARGET "${OPENGL_LIBRARIES}")
    include_directories(${OPENGL_INCLUDE_DIR})
  endif()
  set (G2O_HAVE_OPENGL 1)
  message(STATUS "Compiling with OpenGL support")
  #message(WARNING G2O_OPENGL_TARGET=${G2O_OPENGL_TARGET})
endif()

# For building the GUI
find_package(QGLViewer)

# Logging library
option(G2O_USE_LOGGING "Try to use spdlog for logging" ON)
if (G2O_USE_LOGGING)
  find_package(spdlog 1.6 QUIET)
  if (TARGET spdlog::spdlog OR TARGET spdlog::spdlog_header_only)
    set (G2O_HAVE_LOGGING 1)
    message(STATUS "Compiling with logging support")
  endif()
endif()

# Handle building the built in types. There is a fair degree of
# granularity and dependency in the types supported.

# 2D types
option(G2O_BUILD_SLAM2D_TYPES "Build SLAM2D types" ON)
option(G2O_BUILD_SLAM2D_ADDON_TYPES "Build SLAM2D addon types" ON)
option(G2O_BUILD_DATA_TYPES "Build SLAM2D data types" ON)
option(G2O_BUILD_SCLAM2D_TYPES "Build SCLAM2D types" ON)

# Process the arguments. If G2O_BUILD_SLAM2D_TYPES is disabled, forceably
# disable all types. Otherwise, update messages on the types enabled.
if(G2O_BUILD_SLAM2D_TYPES)
  string(APPEND supported_types_message " slam2d")
  # Make sure that we can't activate both types
  if(G2O_BUILD_SLAM2D_ADDON_TYPES)
    string(APPEND supported_types_message " slam2d (addons)")
  endif()
  if(G2O_BUILD_DATA_TYPES)
    string(APPEND supported_types_message " data")
  endif()
  if(G2O_BUILD_SCLAM2D_TYPES)
    string(APPEND supported_types_message " sclam2d")
  endif()
else()
  set(G2O_BUILD_SLAM2D_ADDON_TYPES OFF)
  set(G2O_BUILD_DATA_TYPES OFF)
  set(G2O_BUILD_SCLAM2D_TYPES OFF)
endif()

# 3D types
option(G2O_BUILD_SLAM3D_TYPES "Build SLAM 3D types" ON)
option(G2O_BUILD_SLAM3D_ADDON_TYPES "Build SLAM 3D addon types" ON)
option(G2O_BUILD_SBA_TYPES "Build SLAM3D SBA types" ON)
option(G2O_BUILD_ICP_TYPES "Build SLAM3D ICP types" ON)
option(G2O_BUILD_SIM3_TYPES "Build SLAM3D sim3 types" ON)

# Process the arguments. If G2O_BUILD_SLAM3D_TYPES is disabled, forceably
# disable all the types. Enable SBA if it's not enabled but one of it's
# dependents is enabled.
if(G2O_BUILD_SLAM3D_TYPES)
  string(APPEND supported_types_message " slam3d")
  message(STATUS "Compiling SLAM 3D types")
  if (G2O_BUILD_SLAM3D_ADDON_TYPES)
    string(APPEND supported_types_message " slam3d (addons)")
  endif()
  if (G2O_BUILD_SBA_TYPES)
    string(APPEND supported_types_message " sba")
  endif()
  if (G2O_BUILD_ICP_TYPES)
    if(NOT G2O_BUILD_SBA_TYPES)
      message(WARNING "ICP types requested but SBA types not enabled; enabling SBA")
      set(G2O_BUILD_SBA_TYPES ON)
      string(APPEND supported_types_message " sba")
    endif()
    string(APPEND supported_types_message " icp")
  endif()
  if (G2O_BUILD_SIM3_TYPES)
    if(NOT G2O_BUILD_SBA_TYPES)
      message(WARNING "SIM3 types requested but SBA types not enabled; enabling SBA")
      set(G2O_BUILD_SBA_TYPES ON)
      string(APPEND supported_types_message " sba")
    endif()
    string(APPEND supported_types_message " sim3")
  endif()
else()
  set(G2O_BUILD_SLAM3D_ADDON_TYPES OFF)
  set(G2O_BUILD_SBA_TYPES OFF)
  set(G2O_BUILD_ICP_TYPES OFF)
  set(G2O_BUILD_SIM3_TYPES OFF)
endif()

if(DEFINED supported_types_message)
  message(STATUS "Compiling built in types" ${supported_types_message})
else()
  message(STATUS "Compiling with no built in types enabled")
endif()

# shall we build the core apps using the library
option(G2O_BUILD_APPS "Build g2o apps" ON)
if(G2O_BUILD_APPS)
  message(STATUS "Compiling g2o apps")
endif(G2O_BUILD_APPS)

include(CMakeDependentOption)
CMAKE_DEPENDENT_OPTION(G2O_BUILD_LINKED_APPS "Build apps linked with the libraries (no plugin system)" OFF
  "G2O_BUILD_APPS" OFF)

# shall we build the examples
option(G2O_BUILD_EXAMPLES "Build g2o examples" ON)
if(G2O_BUILD_EXAMPLES)
  message(STATUS "Compiling g2o examples")
endif(G2O_BUILD_EXAMPLES)

option(G2O_FAST_MATH "Enable fast math operations" OFF)
option(G2O_NO_IMPLICIT_OWNERSHIP_OF_OBJECTS "Disables memory management in the graph types, this requires the callers to manager the memory of edges and nodes" OFF)

# Start of SSE* autodetect code
# (borrowed from MRPT CMake scripts, BSD)
option(DO_SSE_AUTODETECT "Enable autodetection of SSE* CPU sets and enable their use in optimized code" ON)
if(NOT EXISTS "/proc/cpuinfo")
	set(DO_SSE_AUTODETECT OFF)
endif()
if (DO_SSE_AUTODETECT)
  file(READ "/proc/cpuinfo" G2O_CPU_INFO)
endif()

# Macro for each SSE* var: Invoke with name in uppercase:
macro(DEFINE_SSE_VAR  _setname)
	string(TOLOWER ${_setname} _set)
	if (DO_SSE_AUTODETECT)
		# Automatic detection:
		set(CMAKE_G2O_HAS_${_setname} 0)
		if (${G2O_CPU_INFO} MATCHES ".*${_set}.*")
			set(CMAKE_G2O_HAS_${_setname} 1)
		endif()
	else (DO_SSE_AUTODETECT)
		# Manual:
		option("DISABLE_${_setname}" "Forces compilation WITHOUT ${_setname} extensions" OFF)
		mark_as_advanced("DISABLE_${_setname}")
		set(CMAKE_G2O_HAS_${_setname} 0)
		if (NOT DISABLE_${_setname})
			set(CMAKE_G2O_HAS_${_setname} 1)
		endif (NOT DISABLE_${_setname})
	endif (DO_SSE_AUTODETECT)
endmacro(DEFINE_SSE_VAR)

# SSE optimizations:
DEFINE_SSE_VAR(SSE2)
DEFINE_SSE_VAR(SSE3)
DEFINE_SSE_VAR(SSE4_1)
DEFINE_SSE_VAR(SSE4_2)
DEFINE_SSE_VAR(SSE4_A)

include(CheckCXXCompilerFlag)

macro(CHECK_AND_ADD_COMPILE_OPTION _option _option_name)
  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    check_cxx_compiler_flag("-Werror=unused-command-line-argument ${_option}" ${_option_name}_AVAILABLE)
  else()
    check_cxx_compiler_flag(${_option} ${_option_name}_AVAILABLE)
  endif()
  if(${_option_name}_AVAILABLE)
    add_compile_options(${_option})
  endif()
endmacro()

# Add build flags for clang AND GCC
if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
  # SSE2?
  if (CMAKE_G2O_HAS_SSE2)
    CHECK_AND_ADD_COMPILE_OPTION(-msse2 SSE2)
  endif()
  # SSE3?
  if (CMAKE_G2O_HAS_SSE3)
    CHECK_AND_ADD_COMPILE_OPTION(-msse3 SSE3)
    CHECK_AND_ADD_COMPILE_OPTION(-mssse3 SSSE3)
  endif()
  # SSE4*?
  if (CMAKE_G2O_HAS_SSE4_1)
    CHECK_AND_ADD_COMPILE_OPTION(-msse4.1 SSE41)
  endif()
  if (CMAKE_G2O_HAS_SSE4_2)
    CHECK_AND_ADD_COMPILE_OPTION(-msse4.2 SSE42)
  endif()
  if (CMAKE_G2O_HAS_SSE4_A)
    CHECK_AND_ADD_COMPILE_OPTION(-msse4a SSE4a)
  endif()
endif()
# End of of SSE* autodetect code -------

# code coverage
option(BUILD_CODE_COVERAGE "Enable coverage reporting" OFF)
if(BUILD_CODE_COVERAGE AND CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")

=== Makefile ===
SHELL = /bin/bash

ifeq ($(VERBOSE), 1)
QUIET=
else
QUIET=-s --no-print-directory
endif

all: build/Makefile
	@ $(MAKE) $(QUIET) -C build

debug: build/Makefile
	@ $(MAKE) $(QUIET) -C build

clean: build/Makefile
	@ $(MAKE) $(QUIET) -C build clean

build/Makefile:
	@ echo "Running cmake to generate Makefile"; \
	cd build; \
	cmake ../; \
	cd -

=== benchmarks/CMakeLists.txt ===
add_executable(benchmark_jacobian_timing jacobian_timing_tests.cpp)

target_include_directories(benchmark_jacobian_timing PUBLIC
  "$<BUILD_INTERFACE:${g2o_SOURCE_DIR};${PROJECT_BINARY_DIR}>"
)

target_link_libraries(benchmark_jacobian_timing benchmark::benchmark ${G2O_EIGEN3_EIGEN_TARGET})

=== doc/Makefile ===
all: g2o.pdf

pics/%.svg: pics/%.fig
	fig2dev -L svg $< $@
pics/%.pdf: pics/%.fig
	fig2dev -L pdf $< $@

g2o.pdf: g2o.tex pics/classes.pdf pics/hgraph.pdf pics/slam.pdf
	pdflatex g2o.tex
	bibtex g2o
	pdflatex g2o.tex
	pdflatex g2o.tex

clean:
	rm -rf pics/*.svg pics/*.pdf *.log
.PHONY: clean

=== g2o/CMakeLists.txt ===
add_subdirectory(EXTERNAL)
add_subdirectory(autodiff)
add_subdirectory(stuff)
add_subdirectory(core)

if(G2O_BUILD_APPS)
  add_subdirectory(apps)
endif(G2O_BUILD_APPS)

# Pre-canned types
add_subdirectory(types)

# Solvers
add_subdirectory(solvers)

# Examples
if(G2O_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif(G2O_BUILD_EXAMPLES)

if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/playground")
  # Playground
  option (G2O_BUILD_PLAYGROUND "Build g2o playground" ON)
  if (G2O_BUILD_PLAYGROUND)
    message(STATUS "building playground")
    add_subdirectory(playground)
  endif()
endif()

=== unit_test/CMakeLists.txt ===
include(FetchContent)
FetchContent_Declare(
  googletest
  GIT_REPOSITORY https://github.com/google/googletest.git
  GIT_TAG        main
)
# For Windows: Prevent overriding the parent project's compiler/linker settings
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
FetchContent_MakeAvailable(googletest)

macro(create_test target)
  target_link_libraries(${target} gmock_main)
  add_test (NAME ${target} COMMAND $<TARGET_FILE:${target}>)
endmacro(create_test)

add_subdirectory(general)
add_subdirectory(data)
add_subdirectory(stuff)
add_subdirectory(sclam2d)
add_subdirectory(slam2d)
add_subdirectory(slam2d_addons)
add_subdirectory(slam3d)
add_subdirectory(slam3d_addons)
add_subdirectory(sim3)
add_subdirectory(sba)
add_subdirectory(solver)

=== g2o/EXTERNAL/CMakeLists.txt ===
if (G2O_HAVE_OPENGL)
  add_subdirectory(freeglut)
endif()

=== g2o/apps/CMakeLists.txt ===
add_subdirectory(g2o_cli)

if (G2O_HAVE_OPENGL AND G2O_BUILD_SLAM2D_TYPES  AND G2O_BUILD_SLAM3D_TYPES)
  add_subdirectory(g2o_simulator)
endif()

if(QGLVIEWER_FOUND AND Qt5_FOUND)
  add_subdirectory(g2o_viewer)
endif()

if(G2O_BUILD_LINKED_APPS AND G2O_BUILD_SBA_TYPES AND G2O_BUILD_SCLAM2D_TYPES)
  add_subdirectory(linked_binaries)
endif()

=== g2o/autodiff/CMakeLists.txt ===
add_library(g2o_ceres_ad INTERFACE)

install(TARGETS g2o_ceres_ad
  EXPORT ${G2O_TARGETS_EXPORT_NAME}
  RUNTIME DESTINATION ${RUNTIME_DESTINATION}
  LIBRARY DESTINATION ${LIBRARY_DESTINATION}
  ARCHIVE DESTINATION ${ARCHIVE_DESTINATION}
  INCLUDES DESTINATION ${INCLUDES_DESTINATION}
)

file(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h" "${CMAKE_CURRENT_SOURCE_DIR}/*.hpp")
install(FILES ${headers} DESTINATION ${INCLUDES_INSTALL_DIR}/autodiff)
install(FILES LICENSE DESTINATION ${INCLUDES_INSTALL_DIR}/autodiff)

=== g2o/core/CMakeLists.txt ===
add_library(core ${G2O_LIB_TYPE}
dynamic_aligned_buffer.hpp
ownership.h
base_edge.h
base_multi_edge.h
base_fixed_sized_edge.h        hyper_graph_action.cpp
base_fixed_sized_edge.hpp      hyper_graph_action.h
base_variable_sized_edge.h     hyper_graph.cpp
base_variable_sized_edge.hpp   hyper_graph.h
base_unary_edge.h           linear_solver.h
base_binary_edge.h          marginal_covariance_cholesky.cpp
base_vertex.h               marginal_covariance_cholesky.h
base_vertex.hpp             matrix_structure.cpp
batch_stats.cpp             matrix_structure.h
batch_stats.h               openmp_mutex.h
block_solver.h              block_solver.hpp
parameter.cpp               parameter.h
cache.cpp                   cache.h
optimizable_graph.cpp       optimizable_graph.h
solver.cpp                  solver.h
creators.h                  optimization_algorithm_factory.cpp
estimate_propagator.cpp     optimization_algorithm_factory.h
estimate_propagator.h
factory.cpp                 optimization_algorithm_property.h
factory.h                   sparse_block_matrix.h
sparse_optimizer.cpp  sparse_block_matrix.hpp
sparse_optimizer.h
hyper_dijkstra.cpp hyper_dijkstra.h
parameter_container.cpp     parameter_container.h
optimization_algorithm.cpp optimization_algorithm.h
optimization_algorithm_with_hessian.cpp optimization_algorithm_with_hessian.h
optimization_algorithm_gauss_newton.cpp optimization_algorithm_gauss_newton.h
optimization_algorithm_levenberg.cpp optimization_algorithm_levenberg.h
optimization_algorithm_dogleg.cpp optimization_algorithm_dogleg.h
sparse_optimizer_terminate_action.cpp sparse_optimizer_terminate_action.h
jacobian_workspace.cpp jacobian_workspace.h
robust_kernel.cpp robust_kernel.h
robust_kernel_impl.cpp robust_kernel_impl.h
robust_kernel_factory.cpp robust_kernel_factory.h
io_helper.h
g2o_core_api.h
)

target_include_directories(core PUBLIC
  "$<BUILD_INTERFACE:${g2o_SOURCE_DIR};${PROJECT_BINARY_DIR}>"
  $<INSTALL_INTERFACE:include/g2o/core>
)

set_target_properties(core PROPERTIES OUTPUT_NAME ${LIB_PREFIX}core)
set_target_properties(core PROPERTIES
  VERSION ${G2O_LIB_VERSION}
  SOVERSION ${G2O_LIB_SOVERSION})
target_link_libraries(core PUBLIC stuff ${G2O_EIGEN3_EIGEN_TARGET})
target_link_libraries(core PUBLIC g2o_ceres_ad)
target_compile_features(core PUBLIC cxx_std_17)

if (APPLE)
  set_target_properties(core PROPERTIES INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif()

install(TARGETS core
  EXPORT ${G2O_TARGETS_EXPORT_NAME}
  RUNTIME DESTINATION ${RUNTIME_DESTINATION}
  LIBRARY DESTINATION ${LIBRARY_DESTINATION}
  ARCHIVE DESTINATION ${ARCHIVE_DESTINATION}
  INCLUDES DESTINATION ${INCLUDES_DESTINATION}
)

file(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h" "${CMAKE_CURRENT_SOURCE_DIR}/*.hpp")

install(FILES ${headers} DESTINATION ${INCLUDES_INSTALL_DIR}/core)

=== g2o/examples/CMakeLists.txt ===
# Self-contained examples which declare their own types
add_subdirectory(data_fitting)
add_subdirectory(dynamic_vertex)
add_subdirectory(bal)
add_subdirectory(target)
add_subdirectory(tutorial_slam2d)

# 2D SLAM examples

if(G2O_BUILD_SCLAM2D_TYPES AND G2O_BUILD_DATA_TYPES)
  add_subdirectory(calibration_odom_laser)
endif()

# 3D examples
if(G2O_BUILD_SBA_TYPES)
  add_subdirectory(ba)
  add_subdirectory(ba_anchored_inverse_depth)
  add_subdirectory(data_convert)
endif()

if (G2O_BUILD_ICP_TYPES)
  add_subdirectory(icp)
  add_subdirectory(sba)
endif()

if (G2O_BUILD_SLAM3D_ADDON_TYPES)
  add_subdirectory(line_slam)
  add_subdirectory(plane_slam)
endif()

if (G2O_BUILD_SIM3_TYPES)
  add_subdirectory(sim3)
endif()

# slam 3d
if (G2O_BUILD_SLAM3D_TYPES)
  add_subdirectory(sphere)
endif()

if(G2O_BUILD_SLAM2D_TYPES AND G2O_BUILD_SLAM3D_TYPES)
  add_subdirectory(anonymize_observations)
  add_subdirectory(interactive_slam)
  add_subdirectory(simple_optimize)
endif()

if(G2O_BUILD_SLAM2D_TYPES AND G2O_BUILD_SLAM2D_ADDON_TYPES AND G2O_BUILD_SLAM3D_TYPES)
  add_subdirectory(convert_segment_line)
endif()

if(Qt5_FOUND AND QGLVIEWER_FOUND)
  add_subdirectory(slam2d)
endif()

# complex example of hierarchical optimization
if (G2O_BUILD_SLAM3D_TYPES)
  add_subdirectory(g2o_hierarchical)
endif()

=== g2o/solvers/CMakeLists.txt ===
add_subdirectory(pcg)
add_subdirectory(dense)

if(G2O_BUILD_SLAM2D_TYPES)
  add_subdirectory(slam2d_linear)
endif()

add_subdirectory(structure_only)

if(CSPARSE_FOUND)
  add_subdirectory(csparse)
endif()

if(CHOLMOD_FOUND)
  add_subdirectory(cholmod)
endif(CHOLMOD_FOUND)

# Sparse Module of Eigen is stable starting from 3.1
add_subdirectory(eigen)

=== debian/changelog ===
g2o (0~20230806-5) unstable; urgency=medium

  * Build is reproducible. Thanks to Chris Lamb (Closes: #1114950)

 -- Dima Kogan <dkogan@debian.org>  Mon, 10 Nov 2025 21:18:45 -0800

g2o (0~20230806-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061964

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 09:35:01 +0000

g2o (0~20230806-4) unstable; urgency=medium

  * Team upload
  * Source-only upload to allow migration to happen
  * Raising Standards version to 4.6.2:
    - Rules-Requires-Root: no

 -- Pierre Gruet <pgt@debian.org>  Thu, 02 Nov 2023 08:00:14 +0100

g2o (0~20230806-3) unstable; urgency=medium

  * Fixed arch=all build (Closes: #1054252)
  * Ifxed arch-i386 build

 -- Dima Kogan <dkogan@debian.org>  Sun, 29 Oct 2023 17:56:35 -0700

g2o (0~20230806-2) unstable; urgency=medium

  * Fixed build on armhf

 -- Dima Kogan <dkogan@debian.org>  Tue, 03 Oct 2023 23:50:24 -0700

g2o (0~20230806-1) unstable; urgency=medium

  * Initial release (Closes: #1031099)

 -- Dima Kogan <dkogan@debian.org>  Sun, 06 Aug 2023 13:04:40 -0700

=== debian/control ===
Source: g2o
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 11),
               cmake,
               libopenblas-dev,
               libsuitesparse-dev,
               libopengl-dev,
               libqglviewer-headers,
               libeigen3-dev,
               libglut-dev,
               libtbb-dev,
               libmetis-dev,
               libceres-dev,
               libgmock-dev
Build-Depends-Indep: 
               doxygen,
               graphviz,
               fig2dev,
               texlive-latex-base,
               texlive-latex-extra,
               texlive-science,
               ghostscript
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.6.2
Homepage: http://www.g2o.org
Vcs-Git: https://salsa.debian.org/science-team/g2o.git
Vcs-Browser: https://salsa.debian.org/science-team/g2o
Rules-Requires-Root: no

Package: libg2o0t64
Provides: ${t64:Provides}
Replaces: libg2o0
Breaks: libg2o0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ framework for optimizing graph-based nonlinear error functions
 A wide range of problems in robotics as well as in computer-vision involve the
 minimization of a non-linear error function that can be represented as a graph.
 Typical instances are simultaneous localization and mapping (SLAM) or bundle
 adjustment (BA). The overall goal in these problems is to find the
 configuration of parameters or state variables that maximally explain a set of
 measurements affected by Gaussian noise. g2o is an open-source C++ framework
 for such nonlinear least squares problems. g2o has been designed to be easily
 extensible to a wide range of problems and a new problem typically can be
 specified in a few lines of code. The current implementation provides solutions
 to several variants of SLAM and BA. g2o offers a performance comparable to
 implementations of state-of-the-art approaches for the specific problems
 (02/2011)

Package: libg2o-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libg2o0t64 (= ${binary:Version}),
         libceres-dev, libeigen3-dev
Recommends: libg2o-doc
Description: C++ framework for optimizing graph-based nonlinear error functions
 A wide range of problems in robotics as well as in computer-vision involve the
 minimization of a non-linear error function that can be represented as a graph.
 Typical instances are simultaneous localization and mapping (SLAM) or bundle
 adjustment (BA). The overall goal in these problems is to find the
 configuration of parameters or state variables that maximally explain a set of
 measurements affected by Gaussian noise. g2o is an open-source C++ framework
 for such nonlinear least squares problems. g2o has been designed to be easily
 extensible to a wide range of problems and a new problem typically can be
 specified in a few lines of code. The current implementation provides solutions
 to several variants of SLAM and BA. g2o offers a performance comparable to
 implementations of state-of-the-art approaches for the specific problems
 (02/2011)
 .
 Development files

Package: libg2o-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: C++ framework for optimizing graph-based nonlinear error functions
 A wide range of problems in robotics as well as in computer-vision involve the
 minimization of a non-linear error function that can be represented as a graph.
 Typical instances are simultaneous localization and mapping (SLAM) or bundle
 adjustment (BA). The overall goal in these problems is to find the
 configuration of parameters or state variables that maximally explain a set of
 measurements affected by Gaussian noise. g2o is an open-source C++ framework
 for such nonlinear least squares problems. g2o has been designed to be easily
 extensible to a wide range of problems and a new problem typically can be
 specified in a few lines of code. The current implementation provides solutions
 to several variants of SLAM and BA. g2o offers a performance comparable to
 implementations of state-of-the-art approaches for the specific problems
 (02/2011)
 .
 Documentation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS   := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

export FORCE_SOURCE_DATE = 1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure --				\
		-DCMAKE_BUILD_TYPE=RelWithDebInfo	\
		-DBUILD_SHARED_LIBS=ON			\
		-DG2O_USE_CHOLMOD=ON			\
		-DG2O_USE_LGPL_LIBS=ON			\
		-DG2O_USE_CSPARSE=ON			\
		-DG2O_USE_OPENMP=OFF			\
		-DG2O_USE_OPENGL=ON			\
		-DG2O_USE_VENDORED_CERES=OFF		\
		-DG2O_BUILD_SLAM2D_TYPES=ON		\
		-DG2O_BUILD_SLAM2D_ADDON_TYPES=ON	\
		-DG2O_BUILD_DATA_TYPES=ON		\
		-DG2O_BUILD_SCLAM2D_TYPES=ON		\
		-DG2O_BUILD_SLAM3D_TYPES=ON		\
		-DG2O_BUILD_SLAM3D_ADDON_TYPES=ON	\
		-DG2O_BUILD_SBA_TYPES=ON		\
		-DG2O_BUILD_ICP_TYPES=ON		\
		-DG2O_BUILD_SIM3_TYPES=ON		\
		-DG2O_BUILD_APPS=ON			\
		-DG2O_BUILD_EXAMPLES=OFF		\
		-DG2O_FAST_MATH=OFF			\
		-DDO_SSE_AUTODETECT=OFF			\
		-DBUILD_CODE_COVERAGE=OFF		\
		-DBUILD_WITH_MARCH_NATIVE=OFF		\
		-DBUILD_UNITTESTS=ON			\
		-DG2O_BUILD_BENCHMARKS=OFF

override_dh_auto_configure-indep:
	true


ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))

override_dh_auto_build-indep:
	$(MAKE) -C doc g2o.pdf
	cd doc/doxygen && doxygen doxy.config

else

override_dh_auto_build-indep:
	true

endif

override_dh_auto_build-arch:
	dh_auto_build


override_dh_auto_test-indep:
	true

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test
else
	true
endif

# remove files I shouldn't ship
override_dh_auto_install-arch:
	dh_auto_install
	rm debian/tmp/usr/include/g2o/autodiff/LICENSE
	sed -i -e 's@^\(#define G2O_SRC_DIR\).*@\1 "/nonexistent"@' debian/tmp/usr/include/g2o/config.h

override_dh_auto_install-indep:
	true
